/*------------------------------------------------------------------------
  13 Mar 2021 Bug: OEM chars in the pallette list are not displayed correctly
        when using ANSI fonts.  Fixed.  Reported by Carlo Hogeveen
 ------------------------------------------------------------------------*/

constant SHOW_FG_TEXT = 0

// Swaps the 1st and 3rd Least Significant Bytes of an integer
// NOTE SIDE-EFFECT: The 4th byte is Zeroed.
integer proc ToggleRGB(integer abc)
    integer cba

    cba = (abc & 0xFF) shl 16
    cba = cba | (abc & 0xFF00)
    cba = cba | ((abc & 0xFF0000) shr 16)

    return(cba)
end

// first is foreground color - 2nd is background
proc TSE_default()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x800000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x000080) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x800080) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x008080) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xc0c0c0) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x808080) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x800000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x000080) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x800080) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x008080) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xc0c0c0) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x808080) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc retro()
//    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x201914) )    // black
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x262626) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x800000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x000080) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x800080) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x008080) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xc0c0c0) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x808080) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

//    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x201914) )    // black
    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x262626) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x800000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x000080) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x800080) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x008080) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xc0c0c0) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x808080) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc solorized1()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x362b00) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x423607) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x756e58) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x837b65) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x969483) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xa1a193) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0xd5e8ee) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xe3f6fd) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x0089b5) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0x164bcb) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x2f32dc) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0x8236d3) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0xc4716c) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xd28b26) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x98a12a) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0x009985) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x362b00) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x423607) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x756e58) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x837b65) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x969483) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xa1a193) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0xd5e8ee) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xe3f6fd) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x0089b5) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0x164bcb) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x2f32dc) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0x8236d3) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0xc4716c) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xd28b26) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x98a12a) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0x009985) )    // white
end

// first is foreground color - 2nd is background
proc solorized2()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x1c1c1c) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x262626) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x585858) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x626262) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x808080) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x8a8a8a) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0xe4e4e4) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xd7ffff) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x0087af) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0x005fd7) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x0000d7) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0x5f00af) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0xaf5f5f) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff8700) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0xafaf00) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0x00875f) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x1c1c1c) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x262626) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x585858) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x626262) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x808080) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x8a8a8a) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0xe4e4e4) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xd7ffff) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x0087af) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0x005fd7) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x0000d7) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0x5f00af) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0xaf5f5f) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff8700) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0xafaf00) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0x00875f) )    // white
end

// first is foreground color - 2nd is background
proc c_HTML()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x8b0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x006400) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x00008b) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x8b008b) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x008b8b) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xd3d3d3) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0xa9a9a9) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x008000) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x8b0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x006400) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x00008b) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x8b008b) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x008b8b) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xd3d3d3) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0xa9a9a9) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x008000) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc c_Brite() //@80x25
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xa00000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00a000) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x00a0a0) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000a0) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xa000a0) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x0050a0) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x505050) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff5050) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x50ff50) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff50) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x5050ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff50ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x50ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xa00000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00a000) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x00a0a0) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000a0) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xa000a0) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x0050a0) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x505050) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff5050) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x50ff50) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff50) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5050ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff50ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x50ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc c_Dark() // >80x25
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x7f0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x007f00) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x7f7f00) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x00007f) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x7f007f) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x007f7f) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xbfbfbf) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x7f7f7f) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x7f0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x007f00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x7f7f00) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x00007f) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x7f007f) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x007f7f) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xbfbfbf) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x7f7f7f) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc c_Brite2() // 80x25#2
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xa80000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00a800) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xa8a800) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000a8) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xa800a8) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x0058a8) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xa8a8a8) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x585858) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff5858) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x58ff58) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff58) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x5858ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff58ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x58ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xa80000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00a800) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xa8a800) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000a8) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xa800a8) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x0058a8) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xa8a8a8) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x585858) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff5858) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x58ff58) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff58) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5858ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff58ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x58ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc FED()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xaa0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00aa00) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xaa5522) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000aa) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xaa00aa) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x00aaaa) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xaaaaaa) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x444444) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff4444) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x44ff44) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff44) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x4444ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff44ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x44ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xaa0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00aa00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xaa5522) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000aa) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xaa00aa) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00aaaa) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xaaaaaa) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x444444) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff4444) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x44ff44) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff44) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x4444ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff44ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x44ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc IBM_CGA()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xaa0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00aa00) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xaaaa00) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000aa) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xaa00aa) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x0055aa) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xaaaaaa) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x555555) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff5555) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x55ff55) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff55) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x5555ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff55ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x55ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xaa0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00aa00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xaaaa00) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000aa) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xaa00aa) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x0055aa) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xaaaaaa) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x555555) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff5555) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x55ff55) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff55) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5555ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff55ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x55ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc _24_BIT()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x840000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x008400) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x848400) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x000084) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x840084) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x008484) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xc6c6c6) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x848484) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x840000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x008400) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x848400) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x000084) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x840084) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x008484) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xc6c6c6) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x848484) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc _1() //Perfect
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xd74b2a) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x14691d) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xd0d029) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x2323ad) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xc02681) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x194a81) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x575757) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xffaf9d) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x7ac581) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xbbdee9) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x3392ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xf3cdff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x33eeff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xd74b2a) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x14691d) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xd0d029) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x2323ad) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xc02681) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x194a81) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x575757) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xffaf9d) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x7ac581) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xbbdee9) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x3392ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xf3cdff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x33eeff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc perfect2() //Perfect
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xad2323) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x1d6914) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x814a19) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x2a4bd7) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x8126c0) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x29d0d0) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x575757) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff9233) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x81c57a) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffee33) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x9dafff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xffcdf3) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0xe9debb) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xad2323) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x1d6914) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x814a19) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x2a4bd7) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x8126c0) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x29d0d0) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x575757) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff9233) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x81c57a) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffee33) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x9dafff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xffcdf3) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0xe9debb) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc _2() // xp boot
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black          1
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xd23e2d) )    // blue           2
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x016553) )    // green          3
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xfc7f5e) )    // cyan           4
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0535b2) )    // red            5
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x151a20) )    // magenta        6
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x009289) )    // brown          7
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0x7e7e7e) )    // light gray     8
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x464646) )    // dark gray      9
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0xffa68d) )    // light blue    10
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0x04dc8e) )    // light green   11
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xfcfcfc) )    // light cyan    12
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x206bf7) )    // light red     13
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xbcbcbc) )    // light magenta 14
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x1bbcf3) )    // yellow        15
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white         16

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black          1
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xd23e2d) )    // blue           2
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x016553) )    // green          3
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xfc7f5e) )    // cyan           4
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0535b2) )    // red            5
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x151a20) )    // magenta        6
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x009289) )    // brown          7
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0x7e7e7e) )    // light gray     8
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x464646) )    // dark gray      9
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xffa68d) )    // light blue    10
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x04dc8e) )    // light green   11
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xfcfcfc) )    // light cyan    12
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x206bf7) )    // light red     13
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xbcbcbc) )    // light magenta 14
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x1bbcf3) )    // yellow        15
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white         16
end

// first is foreground color - 2nd is background
proc ANSIPLUS()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x680000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x336800) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x666600) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x000068) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x680068) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x003366) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xcccccc) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x666666) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff9900) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xcc99ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x680000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x336800) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x666600) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x000068) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x680068) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x003366) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xcccccc) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x666666) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff9900) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xcc99ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc IBM_OEM()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0x990000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x009900) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x999900) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x000099) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x990099) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x0066cc) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xcccccc) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x666666) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff6666) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x66ff66) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff66) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x6666ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff66ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x66ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0x990000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x009900) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x999900) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x000099) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x990099) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x0066cc) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xcccccc) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x666666) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff6666) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x66ff66) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff66) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x6666ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff66ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x66ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc vga()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xaa0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00aa00) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xaa5500) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000aa) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xaa00aa) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x00aaaa) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xaaaaaa) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x555555) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff5555) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x55ff55) )    // light green
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff55) )    // light cyan
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x5555ff) )    // light red
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff55ff) )    // light magenta
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x55ffff) )    // yellow
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xaa0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00aa00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xaa5500) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000aa) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xaa00aa) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00aaaa) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xaaaaaa) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x555555) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff5555) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x55ff55) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff55) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5555ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff55ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x55ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc efte()
    SetColorTableValue(_FOREGROUND_,  0, ToggleRGB(0x000000) )  // black
    SetColorTableValue(_FOREGROUND_,  1, ToggleRGB(0x542400) )  // blue
    SetColorTableValue(_FOREGROUND_,  2, ToggleRGB(0x347c04) )  // green
    SetColorTableValue(_FOREGROUND_,  3, ToggleRGB(0x9c7c00) )  // cyan
    SetColorTableValue(_FOREGROUND_,  4, ToggleRGB(0x000098) )  // red
    SetColorTableValue(_FOREGROUND_,  5, ToggleRGB(0xfca800) )  // magenta
    SetColorTableValue(_FOREGROUND_,  6, ToggleRGB(0x008888) )  // brown
    SetColorTableValue(_FOREGROUND_,  7, ToggleRGB(0xa8a8a8) )  // light gray
    SetColorTableValue(_FOREGROUND_,  8, ToggleRGB(0x404040) )  // dark gray
    SetColorTableValue(_FOREGROUND_,  9, ToggleRGB(0xac7c54) )  // light blue
    SetColorTableValue(_FOREGROUND_, 10, ToggleRGB(0x90f454) )  // light green
    SetColorTableValue(_FOREGROUND_, 11, ToggleRGB(0xfce054) )  // light cyan
    SetColorTableValue(_FOREGROUND_, 12, ToggleRGB(0x5468fc) )  // light red
    SetColorTableValue(_FOREGROUND_, 13, ToggleRGB(0xb084fc) )  // light magenta
    SetColorTableValue(_FOREGROUND_, 14, ToggleRGB(0x54fcfc) )  // yellow
    SetColorTableValue(_FOREGROUND_, 15, ToggleRGB(0xe4fcfc) )  // white

    SetColorTableValue(_BACKGROUND_,  0, ToggleRGB(0x000000) )  // black
    SetColorTableValue(_BACKGROUND_,  1, ToggleRGB(0x542400) )  // blue
    SetColorTableValue(_BACKGROUND_,  2, ToggleRGB(0x347c04) )  // green
    SetColorTableValue(_BACKGROUND_,  3, ToggleRGB(0x9c7c00) )  // cyan
    SetColorTableValue(_BACKGROUND_,  4, ToggleRGB(0x000098) )  // red
    SetColorTableValue(_BACKGROUND_,  5, ToggleRGB(0xfca800) )  // magenta
    SetColorTableValue(_BACKGROUND_,  6, ToggleRGB(0x008888) )  // brown
    SetColorTableValue(_BACKGROUND_,  7, ToggleRGB(0xa8a8a8) )  // light gray
    SetColorTableValue(_BACKGROUND_,  8, ToggleRGB(0x404040) )  // dark gray
    SetColorTableValue(_BACKGROUND_,  9, ToggleRGB(0xac7c54) )  // light blue
    SetColorTableValue(_BACKGROUND_, 10, ToggleRGB(0x90f454) )  // light green
    SetColorTableValue(_BACKGROUND_, 11, ToggleRGB(0xfce054) )  // light cyan
    SetColorTableValue(_BACKGROUND_, 12, ToggleRGB(0x5468fc) )  // light red
    SetColorTableValue(_BACKGROUND_, 13, ToggleRGB(0xb084fc) )  // light magenta
    SetColorTableValue(_BACKGROUND_, 14, ToggleRGB(0x54fcfc) )  // yellow
    SetColorTableValue(_BACKGROUND_, 15, ToggleRGB(0xe4fcfc) )  // white
end

// first is foreground color - 2nd is background
proc web1()
    SetColorTableValue(_FOREGROUND_,  0, ToggleRGB(0x000000) )  // black
    SetColorTableValue(_FOREGROUND_,  4, ToggleRGB(0xaa0000) )  // blue
    SetColorTableValue(_FOREGROUND_,  2, ToggleRGB(0x00aa00) )  // green
    SetColorTableValue(_FOREGROUND_,  6, ToggleRGB(0xffaa00) )  // cyan
    SetColorTableValue(_FOREGROUND_,  1, ToggleRGB(0x0000aa) )  // red
    SetColorTableValue(_FOREGROUND_,  5, ToggleRGB(0xaa00aa) )  // magenta
    SetColorTableValue(_FOREGROUND_,  3, ToggleRGB(0x00aaaa) )  // brown
    SetColorTableValue(_FOREGROUND_,  7, ToggleRGB(0xaaaaaa) )  // light gray
    SetColorTableValue(_FOREGROUND_,  8, ToggleRGB(0x555555) )  // dark gray
    SetColorTableValue(_FOREGROUND_, 12, ToggleRGB(0xff5555) )  // light blue
    SetColorTableValue(_FOREGROUND_, 10, ToggleRGB(0x55ff55) )  // light green
    SetColorTableValue(_FOREGROUND_, 14, ToggleRGB(0xffff55) )  // light cyan
    SetColorTableValue(_FOREGROUND_,  9, ToggleRGB(0x5555ff) )  // light red
    SetColorTableValue(_FOREGROUND_, 13, ToggleRGB(0xff55ff) )  // light magenta
    SetColorTableValue(_FOREGROUND_, 11, ToggleRGB(0x55ffff) )  // yellow
    SetColorTableValue(_FOREGROUND_, 15, ToggleRGB(0xffffff) )  // white

    SetColorTableValue(_BACKGROUND_,  0, ToggleRGB(0x000000) )  // black
    SetColorTableValue(_BACKGROUND_,  4, ToggleRGB(0x2a0000) )  // blue
    SetColorTableValue(_BACKGROUND_,  2, ToggleRGB(0x002a00) )  // green
    SetColorTableValue(_BACKGROUND_,  6, ToggleRGB(0x2a2a00) )  // cyan
    SetColorTableValue(_BACKGROUND_,  1, ToggleRGB(0x00002a) )  // red
    SetColorTableValue(_BACKGROUND_,  5, ToggleRGB(0x2a002a) )  // magenta
    SetColorTableValue(_BACKGROUND_,  3, ToggleRGB(0x002a2a) )  // brown
    SetColorTableValue(_BACKGROUND_,  7, ToggleRGB(0x2a2a2a) )  // light gray
    SetColorTableValue(_BACKGROUND_,  8, ToggleRGB(0x151515) )  // dark gray
    SetColorTableValue(_BACKGROUND_, 12, ToggleRGB(0x3f1515) )  // light blue
    SetColorTableValue(_BACKGROUND_, 10, ToggleRGB(0x153f15) )  // light green
    SetColorTableValue(_BACKGROUND_, 14, ToggleRGB(0x3f3f15) )  // light cyan
    SetColorTableValue(_BACKGROUND_,  9, ToggleRGB(0x15153f) )  // light red
    SetColorTableValue(_BACKGROUND_, 13, ToggleRGB(0x3f153f) )  // light magenta
    SetColorTableValue(_BACKGROUND_, 11, ToggleRGB(0x153f3f) )  // yellow
    SetColorTableValue(_BACKGROUND_, 15, ToggleRGB(0x3f3f3f) )  // white
end

//  9 becomes 12
// 12 to 13
// 11 to  9
// 13 to 11
// 3 to 6
// first is foreground color - 2nd is background
proc web2()
    SetColorTableValue(_FOREGROUND_,  0, ToggleRGB(0x000000) )  // black
    SetColorTableValue(_FOREGROUND_,  1, ToggleRGB(0xaa0000) )  // red
    SetColorTableValue(_FOREGROUND_,  2, ToggleRGB(0x00aa00) )  // green
    SetColorTableValue(_FOREGROUND_,  3, ToggleRGB(0xffaa00) )  // brown
    SetColorTableValue(_FOREGROUND_,  4, ToggleRGB(0x0000aa) )  // blue
    SetColorTableValue(_FOREGROUND_,  5, ToggleRGB(0xaa00aa) )  // magenta
    SetColorTableValue(_FOREGROUND_,  6, ToggleRGB(0x00aaaa) )  // cyan
    SetColorTableValue(_FOREGROUND_,  7, ToggleRGB(0xaaaaaa) )  // light gray
    SetColorTableValue(_FOREGROUND_,  8, ToggleRGB(0x555555) )  // dark gray
    SetColorTableValue(_FOREGROUND_,  9, ToggleRGB(0xff5555) )  // light red
    SetColorTableValue(_FOREGROUND_, 10, ToggleRGB(0x55ff55) )  // light green
    SetColorTableValue(_FOREGROUND_, 11, ToggleRGB(0xffff55) )  // yellow
    SetColorTableValue(_FOREGROUND_, 12, ToggleRGB(0x5555ff) )  // light blue
    SetColorTableValue(_FOREGROUND_, 13, ToggleRGB(0xff55ff) )  // light magenta
    SetColorTableValue(_FOREGROUND_, 14, ToggleRGB(0x55ffff) )  // light cyan
    SetColorTableValue(_FOREGROUND_, 15, ToggleRGB(0xffffff) )  // white

    SetColorTableValue(_BACKGROUND_,  0, ToggleRGB(0x000000) )  // black
    SetColorTableValue(_BACKGROUND_,  1, ToggleRGB(0xaa0000) )  // red
    SetColorTableValue(_BACKGROUND_,  2, ToggleRGB(0x00aa00) )  // green
    SetColorTableValue(_BACKGROUND_,  3, ToggleRGB(0xffaa00) )  // brown
    SetColorTableValue(_BACKGROUND_,  4, ToggleRGB(0x0000aa) )  // blue
    SetColorTableValue(_BACKGROUND_,  5, ToggleRGB(0xaa00aa) )  // magenta
    SetColorTableValue(_BACKGROUND_,  6, ToggleRGB(0x00aaaa) )  // cyan
    SetColorTableValue(_BACKGROUND_,  7, ToggleRGB(0xaaaaaa) )  // light gray
    SetColorTableValue(_BACKGROUND_,  8, ToggleRGB(0x555555) )  // dark gray
    SetColorTableValue(_BACKGROUND_,  9, ToggleRGB(0xff5555) )  // light red
    SetColorTableValue(_BACKGROUND_, 10, ToggleRGB(0x55ff55) )  // light green
    SetColorTableValue(_BACKGROUND_, 11, ToggleRGB(0xffff55) )  // yellow
    SetColorTableValue(_BACKGROUND_, 12, ToggleRGB(0x5555ff) )  // light blue
    SetColorTableValue(_BACKGROUND_, 13, ToggleRGB(0xff55ff) )  // light magenta
    SetColorTableValue(_BACKGROUND_, 14, ToggleRGB(0x55ffff) )  // light cyan
    SetColorTableValue(_BACKGROUND_, 15, ToggleRGB(0xffffff) )  // white
end

// first is foreground color - 2nd is background
proc light_color()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xff0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x000080) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x800080) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x008080) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x808080) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xf45f39) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x008000) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffcc66) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x0000ff) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x02d2ee) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xfffff0) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xff0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x808000) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x000080) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x800080) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x008080) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xa0a0a0) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x808080) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xf45f39) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x008000) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffcc66) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x0000ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x02d2ee) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xfffff0) )    // white
end

// first is foreground color - 2nd is background, using standard xterm
proc xterm_opiz()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0xb2b2b2) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xcd2828) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x28cd28) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xcdcd47) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x6b6bed) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xcd28cd) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x28cdcd) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xe5e5e5) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0xb2b2b2) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff5959) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x59ff59) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff7f) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x7f7fff) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff59ff) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x59ffff) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xcd0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00cd00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xcdcd00) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000ee) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xcd00cd) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00cdcd) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xe5e5e5) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x7f7f7f) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5c5cff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc term_app()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xc23621) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x25bc26) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xadad27) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x492ee1) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xd338d3) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x33bbc8) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xcbcccd) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x818383) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xfc391f) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x31e722) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xeaec23) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x5833ff) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xf935f8) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x14f0f0) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xe9ebeb) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xc23621) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x25bc26) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xadad27) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x492ee1) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xd338d3) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x33bbc8) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xcbcccd) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x818383) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xfc391f) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x31e722) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xeaec23) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5833ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xf935f8) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x14f0f0) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xe9ebeb) )    // white
end

// first is foreground color - 2nd is background
proc putty()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xbb0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00bb00) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xbbbb00) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000bb) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xbb00bb) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x00bbbb) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xbbbbbb) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x555555) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff5555) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x55ff55) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff55) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x5555ff) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff55ff) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x55ffff) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xbb0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00bb00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xbbbb00) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000bb) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xbb00bb) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00bbbb) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xbbbbbb) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x555555) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff5555) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x55ff55) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff55) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5555ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff55ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x55ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc xterm()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xcd0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00cd00) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xcdcd00) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000ee) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xcd00cd) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x00cdcd) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xe5e5e5) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x7f7f7f) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x00ff00) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffff00) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x5c5cff) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x00ffff) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xcd0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00cd00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xcdcd00) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000ee) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xcd00cd) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00cdcd) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xe5e5e5) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x7f7f7f) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x00ff00) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffff00) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x5c5cff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x00ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc css_html()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xff0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x00ff00) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xffff00) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000ff) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xff00ff) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x00ffff) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xffffff) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0xa9a9a9) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x90ee90) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffffe0) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0xacd8e6) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0xe0ffff) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xff0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x00ff00) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xffff00) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000ff) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xff00ff) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00ffff) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xffffff) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0xa9a9a9) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x90ee90) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffffe0) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0xacd8e6) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0xe0ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc x_windows()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xff0000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xffff00) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0000ff) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xff00ff) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x00ffff) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xffffff) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0xa9a9a9) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x90ee90) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0xffffe0) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0xacd8e6) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0xe0ffff) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffff) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x000000) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xff0000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x008000) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xffff00) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0000ff) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xff00ff) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00ffff) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xffffff) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0xa9a9a9) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xff0000) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x90ee90) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0xffffe0) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0xacd8e6) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xff00ff) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0xe0ffff) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffff) )    // white
end

// first is foreground color - 2nd is background
proc solorized5()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x073642) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xdc322f) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x859900) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xb58900) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x268bd2) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xd33682) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x2aa198) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xeee8d5) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x002b36) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xcb4b16) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x586e75) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0x657b83) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x839496) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0x6c71c4) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x93a1a1) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xfdf6e3) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x073642) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xdc322f) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x859900) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xb58900) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x268bd2) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xd33682) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x2aa198) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xeee8d5) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x002b36) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xcb4b16) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x586e75) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0x657b83) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x839496) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0x6c71c4) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x93a1a1) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xfdf6e3) )    // white
end

// first is foreground color - 2nd is background
proc solorized6()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x262626) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xd70000) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x5f8700) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0xaf8700) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0087ff) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0xaf005f) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0x00afaf) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xe4e4e4) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x1c1c1c) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xd75f00) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x585858) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0x626262) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x808080) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0x5f5faf) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0x8a8a8a) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xffffd7) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x262626) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xd70000) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x5f8700) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0xaf8700) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0087ff) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0xaf005f) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0x00afaf) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xe4e4e4) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x1c1c1c) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xd75f00) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x585858) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0x626262) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x808080) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0x5f5faf) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0x8a8a8a) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xffffd7) )    // white
end

// first is foreground color - 2nd is background
proc from_stackoverflow()
    SetColorTableValue(_FOREGROUND_, 0,ToggleRGB(0x0c0c0c) )    // black
    SetColorTableValue(_FOREGROUND_, 1,ToggleRGB(0xc50f1f) )    // blue
    SetColorTableValue(_FOREGROUND_, 2,ToggleRGB(0x13a10e) )    // green
    SetColorTableValue(_FOREGROUND_, 3,ToggleRGB(0x3a96dd) )    // cyan
    SetColorTableValue(_FOREGROUND_, 4,ToggleRGB(0x0037da) )    // red
    SetColorTableValue(_FOREGROUND_, 5,ToggleRGB(0x881798) )    // magenta
    SetColorTableValue(_FOREGROUND_, 6,ToggleRGB(0xc19c00) )    // brown
    SetColorTableValue(_FOREGROUND_, 7,ToggleRGB(0xcccccc) )    // light gray
    SetColorTableValue(_FOREGROUND_, 8,ToggleRGB(0x767676) )    // dark gray
    SetColorTableValue(_FOREGROUND_, 9,ToggleRGB(0xe74856) )    // light blue
    SetColorTableValue(_FOREGROUND_,10,ToggleRGB(0x16c60c) )    // light green          a
    SetColorTableValue(_FOREGROUND_,11,ToggleRGB(0x61d6d6) )    // light cyan           b
    SetColorTableValue(_FOREGROUND_,12,ToggleRGB(0x3b78ff) )    // light red            c
    SetColorTableValue(_FOREGROUND_,13,ToggleRGB(0xb4009e) )    // light magenta        d
    SetColorTableValue(_FOREGROUND_,14,ToggleRGB(0xf9f1a5) )    // yellow               e
    SetColorTableValue(_FOREGROUND_,15,ToggleRGB(0xf2f2f2) )    // white

    SetColorTableValue(_BACKGROUND_, 0,ToggleRGB(0x0c0c0c) )    // black
    SetColorTableValue(_BACKGROUND_, 1,ToggleRGB(0xc50f1f) )    // blue
    SetColorTableValue(_BACKGROUND_, 2,ToggleRGB(0x13a10e) )    // green
    SetColorTableValue(_BACKGROUND_, 3,ToggleRGB(0x3a96dd) )    // cyan
    SetColorTableValue(_BACKGROUND_, 4,ToggleRGB(0x0037da) )    // red
    SetColorTableValue(_BACKGROUND_, 5,ToggleRGB(0x881798) )    // magenta
    SetColorTableValue(_BACKGROUND_, 6,ToggleRGB(0xc19c00) )    // brown
    SetColorTableValue(_BACKGROUND_, 7,ToggleRGB(0xcccccc) )    // light gray
    SetColorTableValue(_BACKGROUND_, 8,ToggleRGB(0x767676) )    // dark gray
    SetColorTableValue(_BACKGROUND_, 9,ToggleRGB(0xe74856) )    // light blue
    SetColorTableValue(_BACKGROUND_,10,ToggleRGB(0x16c60c) )    // light green
    SetColorTableValue(_BACKGROUND_,11,ToggleRGB(0x61d6d6) )    // light cyan
    SetColorTableValue(_BACKGROUND_,12,ToggleRGB(0x3b78ff) )    // light red
    SetColorTableValue(_BACKGROUND_,13,ToggleRGB(0xb4009e) )    // light magenta
    SetColorTableValue(_BACKGROUND_,14,ToggleRGB(0xf9f1a5) )    // yellow
    SetColorTableValue(_BACKGROUND_,15,ToggleRGB(0xf2f2f2) )    // white
end

// Display a color chart
proc chart2()
  integer xoff = 1, yoff = vWhereY() + 1
  integer x, y, attr, kwidth
  string junk[1], attr_str[1]

  junk = ""
  attr_str = ""
  GetStrAttrXY(WhereXAbs(), WhereYAbs(), junk, attr_str, 1)

  kwidth = (query(ScreenCols) - 2) / 16

  Set(Attr, 15)
  Window(xoff, yoff, 2 + kwidth * 16, yoff + 16 + 1)
  ClrScr()
  DrawBox(4, 7)
  FullWindow()
  vGotoxy(1 + xoff, 1 + yoff)
  for y = 0 to 15
    for x = 0 to 15
      attr = (x * 16) + y
      Set(attr, attr)
      PutStr(Format(attr:kwidth:'0':16))
    endfor
    vGotoxy(1 + xoff, y + 2 + yoff)
  endfor
end

proc ColorChart()
    integer xoff = 1, yoff = 1
    integer x, y, attr, kwidth

    if SHOW_FG_TEXT
        xoff = 1 yoff = 1
    else
        xoff = 0 yoff = 0
    endif
    kwidth = 4
    Set(Attr, 0)
    ClrScr()
    if SHOW_FG_TEXT
        Window(xoff, yoff, 2 + kwidth * 16, yoff + 16 + 1)
        DrawBox(4, 7)
    endif
    FullWindow()
    vGotoxy(1 + xoff, 1 + yoff)
    for y = 0 to 15
        for x = 0 to 15
            attr = (x * 16) + y
            Set(attr, attr)
            if SHOW_FG_TEXT
                PutStr(Format(attr:kwidth:'0':16))
            else
                PutStr(Format(' ':kwidth:' '))
            endif
        endfor
        vGotoxy(1 + xoff, y + 2 + yoff)
    endfor
end

proc chart3(integer y)
    integer n, i, j

    n = 0
    y = 1
    for j = 1 to 16
        vgotoxy(68, y)
        for i = 1 to 16
            Set(Attr, n & 0x0f)
            PutStr(Format(n:3:'0':10, ' '))
            n = n + 1
        endfor
        y = y + 1
    endfor

    Set(Attr, 0x9e)
end

proc chart4()
    integer x, y

    x = 32
    y = 37
    PutStrXY(x, y, "Hello, World! - BlockAttr", Query(BlockAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - CurrWinBorderAttr", Query(CurrWinBorderAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - CursorAttr", Query(CursorAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - CursorInBlockAttr", Query(CursorInBlockAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - EOFMarkerAttr", Query(EOFMarkerAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - HiliteAttr", Query(HiliteAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - LineNumbersAttr", Query(LineNumbersAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MenuBorderAttr", Query(MenuBorderAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MenuGrayAttr", Query(MenuGrayAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MenuSelectAttr", Query(MenuSelectAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MenuSelectGrayAttr", Query(MenuSelectGrayAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MenuSelectLtrAttr", Query(MenuSelectLtrAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MenuTextAttr", Query(MenuTextAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MenuTextLtrAttr", Query(MenuTextLtrAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MsgAttr", Query(MsgAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - OtherWinBorderAttr", Query(OtherWinBorderAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - StatusLineAttr", Query(StatusLineAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - TextAttr", Query(TextAttr))
    y = y + 1

    x = 66
    y = 37
    PutStrXY(x, y, "Hello, World! - IncompleteQuoteAttr", Query(IncompleteQuoteAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - NumberAttr", Query(NumberAttr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - Directive1Attr", Query(Directive1Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - Directive2Attr", Query(Directive2Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - Directive3Attr", Query(Directive3Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MultiLnDlmt1Attr", Query(MultiLnDlmt1Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MultiLnDlmt2Attr", Query(MultiLnDlmt2Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - MultiLnDlmt3Attr", Query(MultiLnDlmt3Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - SingleLnDlmt1Attr", Query(SingleLnDlmt1Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - SingleLnDlmt2Attr", Query(SingleLnDlmt2Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - SingleLnDlmt3Attr", Query(SingleLnDlmt3Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - Quote1Attr", Query(Quote1Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - Quote2Attr", Query(Quote2Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - Quote3Attr", Query(Quote3Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - ToEOL1Attr", Query(ToEOL1Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - ToEOL2Attr", Query(ToEOL2Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - ToEOL3Attr", Query(ToEOL3Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords1Attr", Query(KeyWords1Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords2Attr", Query(KeyWords2Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords3Attr", Query(KeyWords3Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords4Attr", Query(KeyWords4Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords5Attr", Query(KeyWords5Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords6Attr", Query(KeyWords6Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords7Attr", Query(KeyWords7Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords8Attr", Query(KeyWords8Attr))
    y = y + 1

    PutStrXY(x, y, "Hello, World! - KeyWords9Attr", Query(KeyWords9Attr))
    y = y + 1
end

datadef pallettes
    "Brite"
    "Brite2 (console colors)"
    "FED"
    "IBM CGA"
    "IBM OEM"
    "VGA"
    "EFTE"
    "Web2"
    "Light color"
    "Putty"
    ""
    "(1)"
    "AnsiPlus"
    "Perfect 2"
    "Term app"
    ""
    "TSE v4 default colors"
    "HTML (from HTML book)"
    "Dark"
    "24 BIT"
    "Retro"
    "Xterm"
    ""
    "(2)"
    "Web1"
    "Xterm optiz"
    "Css html"
    "X windows"
    "Solorized1"
    "Solorized2"
    "Solorized5"
    "Solorized6"
    "From StackOverflow"
end

integer proc build_buffer(var integer pallet_buffer)
    integer nlines

    PushPosition()

    if pallet_buffer == 0
       pallet_buffer = CreateTempBuffer()
    else
       GotoBufferId(pallet_buffer)
       EmptyBuffer()
    endif

    PushBlock()
    InsertData(pallettes)
    PopBlock()

    nlines = NumLines() + 1
    PopPosition()
    return (nlines)
end

proc load_pallette(integer n)
    case n
        when  1 c_Brite()
        when  2 c_Brite2()
        when  3 FED()
        when  4 IBM_CGA()
        when  5 IBM_OEM()
        when  6 vga()
        when  7 efte()
        when  8 web2()
        when  9 light_color()
        when 10 putty()
        when 11
        when 12 _1()
        when 13 ANSIPLUS()
        when 14 perfect2()
        when 15 term_app()
        when 16
        when 17 TSE_default()
        when 18 c_HTML()
        when 19 c_Dark()
        when 20 _24_BIT()
        when 21 retro()
        when 22 xterm()
        when 23
        when 24 _2()
        when 25 web1()
        when 26 xterm_opiz()
        when 27 css_html()
        when 28 x_windows()
        when 29 solorized1()
        when 30 solorized2()
        when 31 solorized5()
        when 32 solorized6()
        when 33 from_stackoverflow()
    endcase
end

constant kSchemes = -1

keydef list_keys
<cursorup>    if not up() endfile() begline() endif
<cursordown>  if not down() begfile() endif
<Alt s>       EndProcess(kSchemes)
end

string list_footer[] = "{Enter}-Load {Alt-S}-Schemes {Esc}-Exit"

proc list_startup()
    UnHook(list_startup)
    enable(list_keys)
    ListFooter(list_footer)
end

integer pallette_buffer

proc main()
    integer y, menu_only, cur_id, first_time, line, result, menu_rows, schemes, esc_pressed, special_effects

    special_effects = Query(SpecialEffects)
    menu_only = trim(Query(MacroCmdLine)) <> ""

    if not menu_only
        PopWinOpen(1, 1, Query(ScreenCols), Query(ScreenRows), 0, "", 0)
    endif

    cur_id = GetBufferId()
    menu_rows = build_buffer(pallette_buffer)
    first_time = true

    schemes = false
    esc_pressed = false
    repeat
        if schemes
            ExecMacro("colors")
            schemes = false
        endif
        y = 0
        if not menu_only
            BufferVideo()
            ColorChart()
            chart2()
            y = vWhereY() + 2
            chart3(y)
            chart4()
            UnBufferVideo()
        endif

        GotoBufferId(pallette_buffer)
        if first_time
            BegFile()
            first_time = false
        endif

        if menu_only
            if menu_rows > Query(ScreenRows)
                y = 1
            else
                y = Query(ScreenRows) / 2 - (menu_rows / 2 + 3)
            endif
        elseif y == 0
            y = 4
        endif

        Hook(_LIST_STARTUP_, list_startup)
        Set(X1, 4)
        Set(Y1, y)
        BufferVideo()

        Set(SpecialEffects, special_effects | _SHOW_OEM_CHARS_)
        result = List("Palette Schemes", Max(LongestLineInBuffer(), Length(list_footer)))
        Set(SpecialEffects, special_effects)

        line = CurrLine()
        GotoBufferId(cur_id)
        case result
            when kSchemes
                schemes = true
            when TRUE
                BufferVideo()
                load_pallette(line)
                GotoBufferId(pallette_buffer)
                if not Down()
                   BegFile()
                endif
                GotoBufferId(cur_id)
                UpdateDisplay(_ALL_WINDOWS_REFRESH_)
                UnBufferVideo()
                VirtualToRealScreen()
            // escape pressed
            when FALSE
                esc_pressed = true
        endcase
        UnBufferVideo()

    until esc_pressed

    if not menu_only
        PopWinClose()   // be sure to close popwin!
    endif
end
